#!/bin/sh

if [ "$DOMAINURL" != "" ]; then
# app1,http,localhost:8080|app2,http,localhost:8081
for fn in ../webapps/*/WEB-INF/export/init/jfcdomain/*.xml; do
for i in `echo $DOMAINURL | tr -s '|' ' '`; do
DOMAINID=`echo $i | cut -d ',' -f 1`
EXP="\(<domainId>$DOMAINID<\/domainId>.*\)\(<\/jfcdomain>\)"
grep -q "$EXP" $fn
if [ "$?" != "0" ]; then
continue
fi
grep -q "<\/url><\/jfcdomain>" $fn
if [ "$?" = "0" ]; then
continue;
fi
PROTO=`echo $i | cut -d ',' -f 2`
URL=`echo $i | cut -d ',' -f 3`
echo $fn
mv $fn $fn.bak
sed "s/$EXP/\1<url>$PROTO:\/\/$URL\/<\/url>\2/" $fn.bak > $fn
rm $fn.bak
done
done
fi

if [ "${VOLUME_MNTDIR}" != "" -a -e $VOLUME_MNTDIR ]; then
    if [ -e ../../export ]; then
        rm -rf ../../export
    fi
    echo "Create symbolic link export"
    if [ ! -e $VOLUME_MNTDIR/export ]; then
        mkdir $VOLUME_MNTDIR/export
    fi
    ln -s $VOLUME_MNTDIR/export ../../export

    if [ -e ../../upload_dir ]; then
        rm -rf ../../upload_dir
    fi
    echo "Create symbolic link upload_dir"
    if [ ! -e $VOLUME_MNTDIR/upload_dir ]; then
        mkdir $VOLUME_MNTDIR/upload_dir
    fi
    ln -s $VOLUME_MNTDIR/upload_dir ../../upload_dir

    if [ -e ../../idxdir ]; then
        rm -rf ../../idxdir
    fi
    echo "Create symbolic link idxdir"
    if [ ! -e $VOLUME_MNTDIR/idxdir ]; then
        mkdir $VOLUME_MNTDIR/idxdir
    fi
    ln -s $VOLUME_MNTDIR/idxdir ../../idxdir

    if [ -e ../../migratedb ]; then
        rm -rf ../../migratedb
    fi
    echo "Create symbolic link migratedb"
    if [ ! -e $VOLUME_MNTDIR/migratedb ]; then
        mkdir $VOLUME_MNTDIR/migratedb
    fi
    ln -s $VOLUME_MNTDIR/migratedb ../../migratedb
fi

grep -q "^127.0.0.1 $HOSTNAME$" /etc/hosts
if [ $? != 0 ]; then
echo "Add $HOSTNAME in hosts"
echo 127.0.0.1 $HOSTNAME >> /etc/hosts
fi

FN_EHCACHE_XML=../webapps/*/WEB-INF/classes/ehcache.xml
#echo FN_EHCACHE_XML $FN_EHCACHE_XML
if [ "${EHCACHE_ACTIVEMQ_BROKERURL}" != "" -a -f ${FN_EHCACHE_XML} ]; then
    echo Replace EhCache ActiveMQ Broker URL ${EHCACHE_ACTIVEMQ_BROKERURL}
    SEP=\;
    if [ "${EHCACHE_PROPERTY_SEPARATOR}" != "" ]; then
        SEP=${EHCACHE_PROPERTY_SEPARATOR}
    fi
    REGEXP1="s~\(providerURL=\)[^${SEP}]*${SEP}~\1${EHCACHE_ACTIVEMQ_BROKERURL}${SEP}~"
    REGEXP2="s~\(userName=\)[^${SEP}]*${SEP}~\1${EHCACHE_ACTIVEMQ_USER}${SEP}~"
    REGEXP3="s~\(password=\)[^${SEP}]*${SEP}~\1${EHCACHE_ACTIVEMQ_PASSWORD}${SEP}~"
    REGEXP="${REGEXP1};${REGEXP2};${REGEXP3}"
    cp ../webapps/*/WEB-INF/classes/ehcache.xml ehcache.xml.orig
    sed "$REGEXP" ehcache.xml.orig > ehcache.xml.new
    cp ehcache.xml.new ../webapps/*/WEB-INF/classes/ehcache.xml
fi

FN_WAGBY_SERVLET_XML=../webapps/*/WEB-INF/wagby-servlet.xml
#echo FN_WAGBY_SERVLET_XML $FN_WAGBY_SERVLET_XML
if [ "${REPLACE_CONFIGUREREDISACTION_NO_OP}" = "true" -a -f ${FN_WAGBY_SERVLET_XML} ]; then
    echo Replace wagby-servlet.xml ConfigureRedisAction.NO_OP
    sed 's/^<\/beans>/<util:constant static-field="org.springframework.session.data.redis.config.ConfigureRedisAction.NO_OP"\/>&/' ${FN_WAGBY_SERVLET_XML} > wagby-servlet.xml.new
    cp wagby-servlet.xml.new ${FN_WAGBY_SERVLET_XML}
fi

echo "use $DB."
FN_CONTEXT_XML=../webapps/*/META-INF/context.xml
#echo FN_CONTEXT_XML $FN_CONTEXT_XML
if [ -f ${FN_CONTEXT_XML} ]; then
    #echo grep APPDBTYPE
    #grep "jdbc:[^:]*:" $FN_CONTEXT_XML | sed "s/^.*jdbc:\([^:]*\):.*$/\1/"
    APPDBTYPE=`grep "jdbc:[^:]*:" $FN_CONTEXT_XML | sed "s/^.*jdbc:\([^:]*\):.*$/\1/"`
fi
echo "application db type $APPDBTYPE"
if [ "${DB}" = "hsqldb" -o "${APPDBTYPE}" = "hsqldb" -o "${APPDBTYPE}" = "" ]; then
    echo "Don't replace db config and execute init_db."
else

if [ "${REPLACE_DB_HOSTNAME}" = "true" ]; then
if [ "${DB_JDBCURL}" != "" ]; then
    DB_JDBCURL2=`echo ${DB_JDBCURL} | sed 's/\&/\\\&amp;/g'`
    echo Replace db config ${DB_JDBCURL2}
    REGEXP="s~url=\"jdbc:[^\"]*\"~url=\"${DB_JDBCURL2}\"~"
else
    echo Replace db config ${DB_HOST}/${DB_DBNAME}
    REGEXP1="s/jdbc:\(postgresql\|mysql\|mariadb\|db2\|firebirdsql\):\/\/[^\/]*\/[^?\"]*/jdbc:\1:\/\/${DB_HOST}\/${DB_DBNAME}/" 
    REGEXP2="s/jdbc:\(sqlserver\):\/\/[^;]*;databasename=[^?\"]*/jdbc:\1:\/\/${DB_HOST};databasename=${DB_DBNAME}/"
    REGEXP="${REGEXP1};${REGEXP2}"
fi # "${DB_JDBCURL}" != ""
    REGEXP_CONTEXT="s/username=\"[^\"]*\"/username=\"${DB_USER}\"/;s/password=\"[^\"]*\"/password=\"${DB_PASSWORD}\"/" 
    sed "$REGEXP;$REGEXP_CONTEXT" ${FN_CONTEXT_XML} > context.xml.new
    cp context.xml.new ${FN_CONTEXT_XML}
    REGEXP_INITDB="s/user=\"[^\"]*\"/user=\"${DB_USER}\"/;s/password=\"[^\"]*\"/password=\"${DB_PASSWORD}\"/"

    FN_INITDB_XML=../webapps/*/WEB-INF/export/conf/initdb.xml
    #echo FN_INITDB_XML $FN_INITDB_XML
if [ -f ${FN_INITDB_XML} ]; then
    sed "$REGEXP;$REGEXP_INITDB" ${FN_INITDB_XML} > initdb.xml.new
    cp initdb.xml.new ${FN_INITDB_XML}
fi
fi # "${REPLACE_DB_HOSTNAME}" = "true"

LOCKDIR=../../migratedb/lock
if [ ! -f "${LOCKDIR}" ]; then
mkdir -p ${LOCKDIR}
fi

if [ "${INIT_DB}" = "true" ]; then
if [ "${ALREADY_INIT_DB_FILE}" = "" ]; then
ALREADY_INIT_DB_FILE=${LOCKDIR}/already_init_db.lck
fi
if [ "${FORCE_INIT_DB}" = "true" -a -f ${ALREADY_INIT_DB_FILE} ]; then
rm -f ${ALREADY_INIT_DB_FILE}
fi
fi # if [ "${INIT_DB}" = "true" ]; then

ALREADY_MIGRATE_DB_FILE=
if [ "${MIGRATE_DB}" != "false" -a -f ./migrate_db.sh ]; then
# wagby.domain.id=1000 -> 1000
DOMAINID=`grep ^wagby\.domain\.id= ../webapps/*/WEB-INF/classes/application.properties | sed 's/^wagby\.domain\.id=//;s/[^0-9]//'`
echo DOMAINID $DOMAINID
# build.timestamp=2020-09-17 15\:43\:07 -> 20200917_154307
BUILDDATE=`grep ^build\.timestamp= ../webapps/*/WEB-INF/classes/buildlog.properties | sed 's/^build\.timestamp=//;s/[^0-9 ]//g;s/ /_/'`
echo BUILDDATE $BUILDDATE
if [ "${DOMAINID}" != "" -a "${BUILDDATE}" != "" ]; then
ALREADY_MIGRATE_DB_FILE=${LOCKDIR}/already_migratedb_${DOMAINID}_${BUILDDATE}.lck
fi
fi # if [ "${MIGRATE_DB}" != "false" -a -f "./migrate_db.sh"]; then

SLEEP_TIME=$((`od -vAn --width=4 -tu4 -N4 < /dev/urandom` % 20))

if [ "${INIT_DB}" = "true" ]; then
if [ ! -f ${ALREADY_INIT_DB_FILE} ]; then
sleep $SLEEP_TIME
if [ ! -f ${ALREADY_INIT_DB_FILE} ]; then
touch ${ALREADY_INIT_DB_FILE}

if [ "${ALREADY_MIGRATE_DB_FILE}" != "" ]; then
if [ ! -f ${ALREADY_MIGRATE_DB_FILE} ]; then
touch ${ALREADY_MIGRATE_DB_FILE} 
fi # if [ ! -f ${ALREADY_MIGRATE_DB_FILE} ]; then
fi # if [ "${ALREADY_MIGRATE_DB_FILE}" != "" ]; then

echo Execute init_db.sh
./init_db.sh

if [ "${ALREADY_MIGRATE_DB_FILE}" != "" ]; then
echo Execute migrate_db.sh
./migrate_db.sh
fi # if [ "${ALREADY_MIGRATE_DB_FILE}" != "" ]; then

fi # if [ ! -f ${ALREADY_INIT_DB_FILE} ]; then
fi # if [ ! -f ${ALREADY_INIT_DB_FILE} ]; then
fi # if [ "${INIT_DB}" = "true" ]; then

if [ "${ALREADY_MIGRATE_DB_FILE}" != "" ]; then
if [ ! -f ${ALREADY_MIGRATE_DB_FILE} ]; then
sleep $SLEEP_TIME
if [ ! -f ${ALREADY_MIGRATE_DB_FILE} ]; then
touch ${ALREADY_MIGRATE_DB_FILE} 
echo Execute migrate_db.sh
./migrate_db.sh
fi # if [ ! -f ${ALREADY_MIGRATE_DB_FILE} ]; then
fi # if [ ! -f ${ALREADY_MIGRATE_DB_FILE} ]; then
fi # if [ "${ALREADY_MIGRATE_DB_FILE}" != "" ]; then

fi # else "${DB}" = "hsqldb" -o "${APPDBTYPE}" = "hsqldb" -o "${APPDBTYPE}" = ""

if [ "$SSM_ACTIVATE_ID" != "" ]; then
  echo "regist amazon-ssm-agent SSM_ACTIVATE_ID:$SSM_ACTIVATE_ID"
  amazon-ssm-agent -register -code "${SSM_ACTIVATE_CODE}" -id "${SSM_ACTIVATE_ID}" -region ${AWS_REGION} -y
  nohup amazon-ssm-agent > /dev/null &
fi

./catalina.sh run

